
TR = 1;         % TR - repetition time [s]
T2 = [0.4 0.3];   % T2 hodnoty 
T1 = [1.5 0.9];   % T1 hodnoty
TE = 0.2;         % TE - time echo, vykresli primky v "case echa"


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% NEMENIT
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

dataSpec = '  || TE = %.1f [s], TR = %.1f [s]';
dataSpecStr = sprintf(dataSpec, TE, TR);

x = [0 0; 0 1];
Tpulse = .00001;
Trelax = .04;
TE = TE/2;

NR = 4;

b1_flip = [zeros(1,50) sinc(-pi:pi/25:pi) zeros(1,50)];
g_flip = [zeros(1, numel(b1_flip)); ones(1, numel(b1_flip))];
b1_flip = pi/2*b1_flip/max(b1_flip)/2.24;
Tp = [ones(size(b1_flip)) * Tpulse];

relax_len = ceil((TR)/Trelax);
b1_end = zeros(1, relax_len);

b1_single = [b1_flip b1_end];
g_single = [g_flip zeros(2, numel(b1_end))];
SE_single = [Tp ones(size(b1_end))*Trelax];

b1_seq = [];
SE_timing = [];
g_seq = [];
for j=1:NR
    tEcho(j) = (j-1)*TR + TE;
    g_seq = [g_seq g_single];
    b1_seq = [b1_seq b1_single];
    SE_timing = [SE_timing SE_single];
end

tPlot = [0];
for i=2:length(SE_timing)
    tPlot(i) = tPlot(i-1) + SE_timing(i);
end

g = [zeros(size(SE_timing))];
f = [-250:5:250];

[mx,my,mz] = bloch(b1_seq,g_seq,SE_timing,T1(1),T2(2),0,x,2); 
[mx2,my2,mz2] = bloch(b1_seq,g_seq,SE_timing,T1(2),T2(2),0,x,2); 

[t2mx,t2my,t2mz] = bloch(b1_seq,g_seq,SE_timing,T1(1),T2(1),0,x,2); 
[t2mx2,t2my2,t2mz2] = bloch(b1_seq,g_seq,SE_timing,T1(1),T2(2),0,x,2);


xnorm = abs(mx);
xnorm2 = abs(mx2);

t2xnorm = abs(t2mx);
t2xnorm2 = abs(t2mx2);
figure;

subplot(211);

plot(tPlot,xnorm(:, 1),'r',tPlot, mz(:, 1),'b');hold on;
plot(tPlot,xnorm2(:, 1),'--r',tPlot, mz2(:, 1),'--b');

for idx = 1 : numel(tEcho)
    plot([tEcho(idx) tEcho(idx)], [-0.1 1], '-k');
end

hold off;
legend('Mxy (t)', 'Mz (t)', 'Mxy_2 (t)', 'Mz_2 (t)');
xlabel('Time (s)');
ylabel('Magnetization');
title( strcat('T1 diff, T2 equal ', dataSpecStr));

subplot(212);

plot(tPlot,t2xnorm(:, 1),'r',tPlot,t2mz(:, 1),'b');hold on;
plot(tPlot,t2xnorm2(:, 1),'--r',tPlot, t2mz2(:, 1),'--b');

for idx = 1 : numel(tEcho)
    plot([tEcho(idx) tEcho(idx)], [-0.1 1], '-k');
end

hold off;
legend('Mxy (t)', 'Mz (t)', 'Mxy_2 (t)', 'Mz_2 (t)');
xlabel('Time (s)');
ylabel('Magnetization');
title( strcat('T1 equal, T2 diff  ', dataSpecStr));
